name Real_Time_clock 
;      8951   
;   DS1307,  DS1621,  24  
;     2424 .
;            
; 0, 1, 2,       1533 24  
;   
;   . . 2010 .


; constant
BQ equ 4000 ; frequency KGz
;   3 
DS1307W   equ    0D0H     ;    1101 000 + 0 
DS1307R   equ    0D1H     ;    1101 000 + 1 
DS1621W   equ    90H      ;    1001 000 + 0
DS1621R   equ    91H      ;    1001 000 + 1
alm_store equ    08H      ;    DS1307

;      

row_led_1 equ p1 ;  
row_led_2 equ p0 ;  ()
row_led_3 equ p2 ;  
dat equ p3.0     ;   ()  
clk equ p3.1     ;   ()
pfi equ p3.2     ;      
kbd equ p3.3     ;    
scl equ p3.5     ;  I2C
sda equ p3.6     ;  I2C
rst equ p3.7     ;  

;    
      dseg at 10h
bitcnt    DATA   10H
bytecnt   DATA   11H
temp1     data   12h
key_push  data   13h      ;   
conf      data   14h      ;  DS1621
hand_temp data   15h      ; 
msb_temp  DATA   16H      ;  
lsb_temp  DATA   17H      ;  
secs      DATA   18H      ; 
mins      DATA   19H      ;
hrs       DATA   1AH      ;
day       DATA   1BH      ;
date      DATA   1CH      ;
month     DATA   1DH      ;
year      DATA   1EH      ;
control   DATA   1FH      ; 
alm_hour  DATA   20H      ;  (ALARM)
alm_min   DATA   21H      ;  (ALARM)
alm_cntrl DATA   22H      ;  (ALARM)
mode      data   23h      ;   
flags     DATA   24H
blink     BIT    FLAGS.0  ; 
key_b     bit    flags.1  ; 
adj       bit    flags.2  ; 
minus     bit    flags.3  ; - 
lastread  BIT    FLAGS.4  ;  - 
ack       BIT    FLAGS.5  ;  
bus_flt   BIT    FLAGS.6  ; 
_2w_busy  BIT    FLAGS.7  


      
      org 28h
 displ01: ds 21
 display: ds 25
 displ02: ds 21    
      org 70h
 stack:   ds 16
       

; 
rst_led macro ; 
    mov row_led_1,#00
    mov row_led_2,#00
    mov row_led_3,#00
    clr rst
    nop
    nop
    setb rst
    endm 
scl_high  macro
          setb   scl      ;  scl
          jnb    scl,$    ; ,   
          endm
     
      cseg
      
 org 0000h
 jmp init
 org 0003h
 reti
 org 0013h
 reti

 org 25h
;    57                
key_tab:
        _0:     db 3Eh,41h,41h,41h,3Eh
        _1:     db 00,00,00,00h,7Fh
        _2:     db 72h,49h,49h,49h,46h
        _3:     db 22h,41h,49h,49h,36h
        _4:     db 07h,08h,08h,08h,7Fh
        _5:     db 2Fh,49h,49h,49h,31h
        _6:     db 3eh,49h,49h,49h,32h
        _7:     db 02,01h,01h,01h,7fh
        _8:     db 36h,49h,49h,49h,36h
        _9:     db 26h,49h,49h,49h,3eh
        _A:     db 7Eh,09h,09h,09h,7Fh
        _B:     db 7Fh,49h,49h,49h,36h
        _C:     db 3eh,41h,41h,41h,22h
        _D:     db 7Fh,41h,41h,41h,3eh
        _E:     db 4Fh,49h,49h,49h,41h
        _F:     db 7Fh,09h,09h,09h,02h
        _H:     db 7Fh,08h,08h,08h,7fh
        _P:     db 7fh,09h,09h,09h,0fh
        _II:    db 7fh,01h,01h,01h,7fh   ; 
        _I:     db 01h,01h,7fh,01h,01h   ; 
        _b:     db 7fh,49h,49h,49h,32h   ; 
        _Q:     db 06h,09h,09h,09h,06h   ; 
digit: 
        hi21:   db 40h,0,0,0,0,02h,0,0,0,0,01h,0,0,0,0,02h,0,0,0,0,40h  
        me25:   db 08h,0,0,0,0,0,0,0,0,0,0,0,08h,0,0,0,0,0,0,0,0,0,0,0,08h
        lo21:   db 01h,0,0,0,0,20h,0,0,0,0,40h,0,0,0,0,20h,0,0,0,0,01h   

 org 100h
 ;**************************************************
 ; 
 
 init:
    mov scon,#40h
    mov ie,#00h
    orl pcon,#80h
    mov sp,#stack-1
    setb clk
    rst_led
    setb sda
    scl_high
    mov flags,#00
    mov mode,#00
    call init_DS1307
    call init_ds1621
    call convert
    
 ;**************************************************
 ;   -      
 ;**************************************************
   
 mine: 
    mov temp1,secs
    call read_clock   ;   
    mov a,mode
    cjne a,#01,ma_0
    jmp ma_7
ma_0: jb key_b,ma_4
      mov a,secs
      anl a,#00001111b  ;   -   10 
      cjne a,#5,ma_1    ;   3- 
      call read_temp    ;  
      call look_up_temp ;    
      call up_disp_temp ;   
      jmp ma_5
ma_1:
    cjne a,#6,ma_2
    jmp ma_5
ma_2:    
    cjne a,#7,ma_3
    jmp ma_5
ma_3:                 
    cjne a,#8,ma_6
    call up_digit
    call draw_hrs
    call draw_mins
    jmp ma_5
ma_6:    
    cjne a,#9,ma_4
    ;call up_disp_day
    jmp ma_5
ma_7:
    call clear_disp
    call up_alarm
    jmp ma_5    
ma_4:                 ;   
    call clear_disp    
    call up_disp      ;   
;  
ma_5:                 
      call scan
      rst_led         ;     
      call check_alarm
      mov a,secs
      cjne a,temp1,ma_8
      jmp mine
ma_8:
      call check_key
      jnb key_b,mine
      call key_serv
      jmp mine

;        
 scan:
    mov r0,#display
    mov 08h,#displ01
    mov 09h,#displ02
    mov a,@r0
    mov row_led_2,a
    setb dat          ;   
    call delay_scan
    inc r0    
    call get_byte
    clr dat
    call delay_scan
    inc r0
    mov r2,#21
loop:                  ;   
      call get_digit
      call get_byte
      call delay_scan  ;  
 lp_0:inc r0           ;   
      djnz r2,loop     ;   
      call get_byte
      call delay_scan
      inc r0
      call get_byte
      call delay_scan
      ret
 
 get_digit:                         ;    
          setb rs0
          mov a,@r0
          mov row_led_1,a
          mov a,@r1
          mov row_led_3,a
          inc r0
          inc r1
          clr rs0
          ret
 get_byte:                          ; -   
                mov a,@r0
                mov row_led_2,a
                clr clk
                nop
                setb clk
                ret
  delay_scan:                       ;
                mov r3,#50h         ;  
                djnz r3,$           ; 480 
                ret
;   
  check_key:
                mov r1,#00
                mov r2,#24
                setb dat
                nop
      chk_01:   clr clk
                nop
                setb clk
                clr dat
                jb kbd,chk_02    ;   
                mov key_push,r1  ;   
                setb key_b       ;   
                jmp chk_03
      chk_02:   inc r1
                djnz r2,chk_01
      chk_03:   ret
                
;       
  up_disp:                          ;  
            mov a,hrs
            mov r0,#display
            call write_bcd
            jnb blink,up_0          ; 1S 
            mov @r0,#14h
            jmp up_00
      up_0: mov @r0,#00h
      up_00:mov a,secs
            cjne a,temp1,up_1
            jmp up_2
       up_1:cpl blink     
       up_2:mov a,mins
            mov r0,#display+14
            call write_bcd
            ret
;      
  up_disp_temp:
           mov a,msb_temp
           mov r0,#display
           call write_bcd
           mov r0,#display+12
           mov @r0,#00h
           mov r0,#display+14
           mov a,#21
           call look_key
           mov a,#0ch
           call look_key
           ret
;    , 
  up_disp_day:
           mov a,day
           mov r0,#display
           call get_day
           push b
           call look_key
           pop acc
           call look_key
           mov @r0,#7fh
           mov r0,#display+14
           mov a,date
           call write_bcd
           ret
;    
  up_digit:
           mov dptr,#digit
           mov r0,#displ01
           mov r2,#67
    p_d01: mov a,#00
           movc a,@a+dptr
           mov @r0,a
           inc dptr
           inc r0
           djnz r2,p_d01
           ret
;   
  up_alarm:
            mov a,alm_hour
            mov r0,#display
            call write_bcd
            mov a,alm_min
            mov r0,#display+14
            call write_bcd
            ret
;   
  clear_disp:
           mov r0,#displ01
           mov r2,#67
           mov a,#00
   cl_d:   mov @r0,a
           inc r0
           djnz r2,cl_d
           ret

;   
   key_serv:

 kp_0:mov a,key_push  ;   
      cjne a,#08h,kp_1
      mov r6,#24h
      mov r4,mode
      cjne r4,#01,kp_00
      mov r5,alm_hour
      call correkt
      mov alm_hour,r5
      jmp kp_4
kp_00:mov r5,hrs
      call correkt
      mov hrs,r5
      jmp kp_4 
 kp_1:cjne a,#09h,kp_2
      mov r6,#60h
      mov r4,mode
      cjne r4,#01,kp_0b
      mov r5,alm_min
      call correkt
      mov alm_min,r5
      jmp kp_4
kp_0b:mov r5,mins
      call correkt
      mov mins,r5
      jmp kp_4
 kp_2:cjne a,#0Ah,kp_3
      mov secs,#00
      jmp kp_4
 kp_3:cjne a,#0Bh,kp_5 
      setb adj
      mov a,#01
      add a,mode
      mov mode,a
      cjne a,#04,kp_5
      mov mode,#00
      jmp kp_5
 kp_4:call set_clock
 kp_5:clr key_b
     
 kp_e:
      ret 
; 
     correkt:
            mov a,#01
            add a,r5
            da a
            mov r5,a
            xch a,r6
            subb a,r6
            jnz crr
            mov r5,#00
     crr:       
         ret
;  BCD 
; ACC     
write_bcd:
         push acc      ;   
         swap a
         anl a,#0fh
         call look_key ;   
         pop acc       ;   
         anl a,#0fh
         call look_key
         ret

;         
look_key:       
         mov dptr,#key_tab
         mov r2,#5
         mov b,#5
         mul ab
     l_k:mov r4,a
         movc a,@a+dptr
         mov @r0,a
         inc r0
         mov a,r4
         inc a
         djnz r2,l_k
         inc r0
         ret

;     
;   -  ,   -  ,  - 
get_day:
         mov b,#2
         dec a
         mov dptr,#day_tab
         mul ab
         mov b,a
         movc a,@a+dptr
         xch a,b
         inc a
         movc a,@a+dptr
         xch a,b
         ret
day_tab:
         db 0bh,0ch,12h,10h,0bh,13h,0ch,11h,04h,13h,12h,13h,0ch,14h
         
        

;***********************************************************
;   DS1307
;***********************************************************
init_DS1307:
         call off       ; 

;   DS1307 

osc_control:
         call send_start
         mov a,#DS1307W 
         call send_byte
         mov a,#00h     ;    00
         call send_byte ; SECONDS REGISTER, ALWAYS LEAVE
         setb lastread  ; REG 00H-BIT #7 = 0 (LOW)
         call send_stop ;  . 00 -  7 = 1 
         call send_start;  
         mov a,#DS1307R ;   1307
         call send_byte
         call read_byte 
         clr acc.7      ;  . 00 -  7  .
osc_set:                ; 
         push acc       ;   
         call send_stop
         call send_start
         mov a,#DS1307W ;   
         call send_byte 
         mov a,#00h     
         call send_byte
         pop acc        ;     
         call send_byte ; 
         call send_stop
         ret

;     DS1307      
;           
;     24H (SECS)  2AH (YEAR)
;     2CH(HRS)  2DH(MINUTES).

read_clock:
         mov r1,#secs    ;  
         mov bytecnt,#00H
         clr lastread
         call send_start
         mov a,#DS1307W
         call send_byte
         mov a,#00H
         call send_byte
         call send_stop
         call send_start
         mov a,#DS1307R
         call send_byte
read_loop:
         mov a,bytecnt
         cjne a,#09H,not_last
         setb lastread
not_last:
         call read_byte
         mov @r1,a
         mov a,bytecnt
         cjne a,#00H,not_first
         mov a,@r1
         clr acc.7      ; ENSURE OSC BIT=0 (ENABLED)
         mov @r1,a
not_first:
         inc r1
         inc bytecnt
         mov a,bytecnt
         cjne a,#0AH,read_loop
         call send_stop
         ret

;  
set_clock:
         call send_start
         mov a,#DS1307W 
         call send_byte
         mov a,#00H     ;    . 00H  DS1307
         call send_byte
         mov r1,#secs    ;      . 
         mov bytecnt,#00
send_loop:
         mov a,@r1      ;     ACC
         call send_byte ;  
         inc r1         ;    
         inc bytecnt
         mov a,bytecnt
         cjne a,#0Ah,send_loop
         call send_stop ;   
         ret
                  

;   
check_alarm:
         mov a,mins
         cjne a,alm_min,off
         mov a,hrs
         cjne a,alm_hour,off
         mov alm_cntrl,#10h  ;     
         call alarm_control
         ret
off:     mov alm_cntrl,#00H
         call alarm_control  ; .   .
         ret


; 
;DS1307    10001Hz
alarm_control:
         call send_start
         mov a,#ds1307w
         call send_byte
         mov a,#07h
         call send_byte
         mov r1,#alm_cntrl
         mov a,@r1         ;10h - alarm on at 1Hz
         call send_byte    ;00h - alarm off$sqw out - gnd 
         call send_stop
         ret 

;   
store_alarms:
         call send_start 
         mov a,#DS1307W                                              
         call send_byte
         mov a,#alm_store;    08H  DS1307
         call send_byte
         mov r1,#alm_hour;      . 
 send_loop2:
         mov a,@r1       ;    .
         call send_byte  ;  
         mov r1,#alm_min
         mov a,@r1       ;    .
         call send_byte  ;  
         call send_stop  
         ret
;***********************************************************
;   DS1621
;***********************************************************
 init_DS1621:
         call send_start
         mov a,#DS1621W
         call send_byte
         mov a,#0ACH
         call send_byte
         mov a,#02H
         call send_byte
         call send_stop
         ret
;   
 read_temp:
         clr lastread
         call send_start
         mov a,#DS1621W
         call send_byte
         mov a,#0AAH
         call send_byte
         call send_start
         mov a,#DS1621R
         call send_byte
         call read_byte
         mov msb_temp,a
         setb lastread
         call read_byte
         mov lsb_temp,a
 ex_read:
         call send_stop
         ret
;  
 convert:
         call send_start
         mov a,#DS1621W
         call send_byte
         mov a,#0EEH
         call send_byte
         call send_stop
         call delay     ;  !
         ret         
;  
 st_conv:
         call send_start
         mov a,#DS1621W
         call send_byte
         mov a,#22H
         call send_byte
         call send_stop
         call delay
         ret         

;***TEMPERATURE TABLE FOR DS1621***
; Range -55 C ... 125 C, step 0,5 C
;       -67 F ... 257 F
; Chip  -  c9h .. 0ffh,9-bit-0,5 C
;       +  00h .. 07bh,9-bit-0,5 C  
 look_up_temp:
         mov a,msb_temp
         clr minus
         jnb acc.7,plus
         setb minus
         anl a,#01111111b
         mov r4,#128
         xch a,r4
         subb a,r4
    plus: 
         call bin_bcd
         mov msb_temp,a
         ret       
;     
; -   
;    -    
  bin_bcd:
         mov b,#100
         div ab
         mov hand_temp,a
         mov a,#10
         xch a,b
         div ab
         swap a
         add a,b      
         ret
         
;***********************************************************
;       I2C
;***********************************************************
send_start:
         setb sda
         scl_high
         setb _2w_busy  ; ,  2-  
         clr ack        ;  
         clr bus_flt    ;   
         jnb scl,fault  ;   
         jnb sda,fault
         setb sda       ;   
         scl_high
         clr sda
         call delay
         clr scl
         ret
fault:
         setb bus_flt
         ret

;     
send_stop:
         clr sda
         scl_high
         setb sda
         clr _2w_busy
         ret
;  
delay:
         nop
         nop                    
         ret

;     
read_byte:
         mov bitcnt,#08H 
         mov a,#00H
         setb sda
 read_bits:
         scl_high       ;  0  1
         mov c,sda      ;     
         rlc a          ;    ACC
         clr scl        ;  1  0
         djnz bitcnt,read_bits
                        ;   8- 
         jb lastread,ackn
                        ;   
         clr sda        ;   ,  ACK-BIT

ackn:
         scl_high       ;  SCL   ACKNOWLEDGE
         clr scl        ;  NOT ACKNOWLEDGE
         ret

;  1    
; ACC    

send_byte:
         mov bitcnt,#08H ;  
sb_loop:
         jnb acc.7,notone;   7  0
         setb sda        ;   ,  SDA
         jmp  one
notone:
         clr sda         ;  SDA 
one:
         scl_high        ;  0  1
         rl a            ;  
         clr scl         ;  1  0
         djnz bitcnt,sb_loop
                         ;   8 
         setb sda        ;  SDA  
         scl_high        ; ACKNOWLEDGE
         clr ack
         jnb sda,sb_ex 
                         ;  ACK 
         setb ack        ;  ACKNOWLEDGE
                         
sb_ex:
         call delay      ; 
         clr scl         ;  1  0
         call delay      ; 
         ret

; *****************************************************************
;  
  draw_hrs:  
        mov a,hrs
        mov r4,mins
        cjne a,#12h,dr02
  dr02: jc dr03
        subb a,#12h
  dr03: cjne r4,#30h,dr00
  dr00: jc dr01
        add a,#01
        da a
  dr01: cjne a,#00h,dr1
        
        
  dr0:  mov dptr,#ta1
        jmp dr_13
 ta1: db 2,10,51h,33,5    
  dr1:  
  
  dr2:  cjne a,#01h,dr3
        mov dptr,#ta2
        jmp dr_13
 ta2: db 3,12,80h,13,20h,34,2    
               
  dr3:  cjne a,#02h,dr4
        mov dptr,#ta3
        jmp dr_13
 ta3: db 3,35,4,37,2,39,1    
     
  dr4:  cjne a,#03h,dr5
        mov dptr,#ta4
        jmp dr_13
 ta4: db 4,35,8,37,8,39,8,41,8    
             
  dr5:  cjne a,#04h,dr6
        mov dptr,#ta5
        jmp dr_13
 ta5: db 3,35,10h,37,20h,39,40h    
     
  dr6:  cjne a,#05h,dr7
        mov dptr,#ta6
        jmp dr_13
 ta6: db 3,34,20h,35,80h,59,2    
   
  dr7:  cjne a,#06h,dr8
        mov dptr,#ta7
        jmp dr_13
 ta7: db 2,33,50h,56,05h    
     
  dr8:  cjne a,#07h,dr9
        mov dptr,#ta8
        jmp dr_13
 ta8: db 3,31,80h,32,20h,53,2    
       
  dr9:  cjne a,#08h,dr10
  dr9_: mov dptr,#ta9
        jmp dr_13
 ta9: db 3,27,40h,29,20h,31,10h    
    
  dr10: cjne a,#09h,dr11
  dr10_:mov dptr,#ta10
        jmp dr_13
 ta10: db 4,25,8,27,8,29,8,31,8    
     
  dr11: cjne a,#10h,dr12
        mov dptr,#ta11
        jmp dr_13
 ta11: db 3,27,1,29,2,31,4    

  dr12: cjne a,#11h,dr14
        mov dptr,#ta12
        jmp dr_13
 ta12: db 3,32,2,7,20h,8,80h     
  dr14: cjne a,#0fh,dr9_
        cjne a,#0eh,dr10_ 
        jmp dr_13
;           
 draw_mins:  
        mov a,mins
        cjne a,#03h,dr_1
  dr_0: mov dptr,#ta_01
        jmp dr_13
 ta_01: db 2,10,55h,33,5      
  
  dr_1: jc dr_0 
  dr_2: cjne a,#08h,dr_3
 dr_02: mov dptr,#ta_02
        jmp dr_13
 ta_02: db 5,34,2,12,80h,13,20h,14,8,15,2      

  dr_3: jc dr_02
        cjne a,#13h,dr_4
 dr_03: mov dptr,#ta_03
        jmp dr_13
 ta_03: db 4,35,4,37,2,39,1,18,80h      

  dr_4: jc dr_03
        cjne a,#18h,dr_5
 dr_04: mov dptr,#ta_04
        jmp dr_13
 ta_04: db 5,35,8,37,8,39,8,41,8,43,8      

  dr_5: jc dr_04
        cjne a,#23h,dr_6
 dr_05: mov dptr,#ta_05
        jmp dr_13
 ta_05: db 4,35,10h,37,20h,39,40h,41,80h      

  dr_6: jc dr_05
        cjne a,#28h,dr_7
 dr_06: mov dptr,#ta_06
        jmp dr_13
 ta_06: db 4,34,20h,35,80h,59,2,60,8      

  dr_7: jc dr_06
        cjne a,#33h,dr_8
 dr_07: mov dptr,#ta_07
        jmp dr_13
 ta_07: db 2,33,58h,56,55h      

  dr_8: jc dr_07
        cjne a,#38h,dr_9
 dr_08: mov dptr,#ta_08
        jmp dr_13
 ta_08: db 4,31,80h,32,20h,52,8,53,2      

  dr_9: jc dr_08
        cjne a,#43h,dr_10
 dr_09: mov dptr,#ta_09
        jmp dr_13
 ta_09: db 4,25,80h,27,40h,29,20h,31,10h      

  dr_10:jc dr_09
        cjne a,#48h,dr_11
 dr_010:mov dptr,#ta_010
        jmp dr_13
 ta_010: db 5,23,8,25,8,27,8,29,8,31,8      

  dr_11:jc dr_010
        cjne a,#53h,dr_12
 dr_011:mov dptr,#ta_011
        jmp dr_13
 ta_011: db 4,2,80h,27,1,29,2,31,4      

  dr_12:cjne a,#58h,dr_013
 dr_012:mov dptr,#ta_012
        jmp dr_13
 ta_012: db 4,6,8,7,20h,9,80h,32,2      
 dr_013:jc dr_012         
        jmp dr_0
  dr_13:    
 ; r2- , r0-, dptr-     
 off_set:                     ; 
           mov a,#00
           movc a,@a+dptr
           mov r2,a
           inc dptr
    o_f01: mov a,#00
           movc a,@a+dptr
           mov r0,a
           mov a,#displ01
           add a,r0
           xch a,r0
           inc dptr
           mov a,#00
           movc a,@a+dptr 
           mov r1,a
           mov a,@r0
           orl a,r1
           mov @r0,a
           inc dptr
           djnz r2,o_f01
           ret

    
    
    end     
